Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/domain.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/domain.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/domain.f90	(revision 5600)
@@ -8,17 +8,122 @@
 !> @brief
 !> This module manage domain computation.
-!
+!>
 !> @details
-!>
-!>
-!>
-!>
+!>    define type TDOM:<br/>
+!> @code
+!>    TYPE(TDOM) :: tl_dom
+!> @endcode
+!>
+!>    to initialize domain structure:<br/>
+!> @code
+!>    tl_dom=dom_init(td_mpp, [id_imin,] [id_imax,] [id_jmin,] [id_jmax],[cd_card])
+!> @endcode
+!>       - td_mpp  is mpp structure of an opened file.
+!>       - id_imin is i-direction sub-domain lower left  point indice
+!>       - id_imax is i-direction sub-domain upper right point indice 
+!>       - id_jmin is j-direction sub-domain lower left  point indice
+!>       - id_jmax is j-direction sub-domain upper right point indice
+!>       - cd_card is the cardinal name (for boundary case) 
+!> 
+!>    to get global domain dimension:<br/>
+!>    - tl_dom\%t_dim0
+!>
+!>    to get NEMO periodicity index of global domain:<br/>
+!>    - tl_dom\%i_perio0
+!>
+!>    to get NEMO pivot point index F(0),T(1):<br/>
+!>    - tl_dom\%i_pivot
+!>
+!>    to get East-West overlap of global domain:<br/>
+!>    - tl_dom\%i_ew0
+!>
+!>    to get selected sub domain dimension:<br/>
+!>    - tl_dom\%t_dim
+!>
+!>    to get NEMO periodicity index of sub domain:<br/>
+!>    - tl_dom\%i_perio
+!>
+!>    to get East-West overlap of sub domain:<br/>
+!>    - tl_dom\%i_ew
+!>
+!>    to get i-direction sub-domain lower left  point indice:<br/>
+!>    - tl_dom\%i_imin
+!>
+!>    to get i-direction sub-domain upper right point indice:<br/>
+!>    - tl_dom\%i_imax
+!>
+!>    to get j-direction sub-domain lower left  point indice:<br/>
+!>    - tl_dom\%i_jmin
+!>
+!>    to get j-direction sub-domain upper right point indice:<br/>
+!>    - tl_dom\%i_jmax
+!>
+!>    to get size of i-direction extra band:<br/>
+!>    - tl_dom\%i_iextra
+!>
+!>    to get size of j-direction extra band:<br/>
+!>    - tl_dom\%i_jextra
+!>
+!>    to get i-direction ghost cell number:<br/>
+!>    - tl_dom\%i_ighost
+!>
+!>    to get j-direction ghost cell number:<br/>
+!>    - tl_dom\%i_jghost
+!>
+!>    to get boundary index:<br/>
+!>    - tl_dom\%i_bdy
+!>       - 0 = no boundary
+!>       - 1 = north
+!>       - 2 = south 
+!>       - 3 = east 
+!>       - 4 = west
+!>
+!>    to clean domain structure:<br/>
+!> @code
+!>    CALL dom_clean(td_dom)
+!> @endcode
+!>       - td_dom is domain structure
+!>
+!>    to print information about domain structure:<br/>
+!> @code
+!>    CALL dom_print(td_dom)
+!> @endcode
+!>
+!>    to get East-West overlap (if any):<br/>
+!> @code
+!>    il_ew=dom_get_ew_overlap(td_lon)
+!> @endcode
+!>       - td_lon : longitude variable structure
+!>
+!>    to add extra bands to coarse grid domain (for interpolation):<br/>
+!> @code
+!>    CALL dom_add_extra( td_dom, id_iext, id_jext ) 
+!> @endcode
+!>       - td_dom is domain structure
+!>       - id_iext is i-direction size of extra bands
+!>       - id_jext is j-direction size of extra bands
+!> 
+!>    to remove extra bands from fine grid (after interpolation):<br/>
+!> @code
+!>    CALL dom_del_extra( td_var, td_dom, id_rho )
+!> @endcode
+!>       - td_var is variable structure to be changed
+!>       - td_dom is domain structure
+!>       - id_rho is a array of refinement factor following i- and j-direction
+!>    
+!>    to reset coarse grid domain witouht extra bands:<br/>
+!> @code
+!>    CALL dom_clean_extra( td_dom )
+!> @endcode
 !>
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!> @todo
-!> - check use of id_pivot
+!> @date November, 2013 - Initial Version
+!> @date September, 2014
+!> - add header
+!> - use zero indice to defined cyclic or global domain
+!> @date October, 2014
+!> - use mpp file structure instead of file
 !> 
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -28,10 +133,9 @@
    USE global                          ! global parameter
    USE fct                             ! basic useful function
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE dim                             ! dimension manager
    USE var                             ! variable manager
-   USE file                            ! file manager
+   USE mpp                             ! mpp file manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
@@ -39,51 +143,57 @@
    PUBLIC :: TDOM     !< domain structure
 
+   PRIVATE :: im_minext !< default minumum number of extraband
+
    ! function and subroutine
-   PUBLIc :: dom_clean     !< clean domain structure
-   PUBLIC :: dom_init      !< initialise domain structure
-   PUBLIC :: dom_print     !< print information about domain
-   PUBLIC :: dom_get_ew_overlap !< get east west overlap
-   PUBLIC :: dom_add_extra   !< add useful extra point to coarse grid for interpolation
-   PUBLIC :: dom_clean_extra  !< reset domain without extra point
-   PUBLIC :: dom_del_extra   !< remove extra point from fine grid after interpolation
+   PUBLIC :: dom_copy            !< copy domain structure
+   PUBLIc :: dom_clean           !< clean domain structure
+   PUBLIC :: dom_init            !< initialise domain structure
+   PUBLIC :: dom_print           !< print information about domain
+   PUBLIC :: dom_add_extra       !< add useful extra bands to coarse grid for interpolation
+   PUBLIC :: dom_clean_extra     !< reset domain without extra bands
+   PUBLIC :: dom_del_extra       !< remove extra point from fine grid after interpolation
     
-   PRIVATE :: dom__define    !< define extract domain indices
-                                            !< define extract domain indices for input domain with
-   PRIVATE :: dom__define_cyclic_north_fold !< - cyclic east-west boundary and north fold boundary condition.
-   PRIVATE :: dom__define_north_fold        !< - north fold boundary condition.
-   PRIVATE :: dom__define_symmetric         !< - symmetric boundary condition across the equator.
-   PRIVATE :: dom__define_cyclic            !< - cyclic east-west boundary.
-   PRIVATE :: dom__define_closed            !< - cyclic east-west boundary.
-   PRIVATE :: dom__check_EW_index           !< check East-West indices
-                                            !< compute size of an extract domain
-   PRIVATE :: dom__size_no_pole             !< - without north fold condition
-   PRIVATE :: dom__size_no_pole_overlap     !< - without north fold condition, and which overlap east-west boundary
-   PRIVATE :: dom__size_no_pole_no_overlap  !< - without north fold condition, and which do not overlap east-west boundary
-   PRIVATE :: dom__size_pole                !< - with north fold condition
-   PRIVATE :: dom__size_pole_overlap        !< - with north fold condition, and which overlap east-west boundary
-   PRIVATE :: dom__size_pole_no_overlap     !< - with north fold condition, and which do not overlap east-west boundary
-
-   !> @struct
-   TYPE TDOM
-      TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim0           !< global domain dimension
-      TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim              !< sub domain dimension
-      INTEGER(i4) :: i_perio0   !< NEMO periodicity index
-      INTEGER(i4) :: i_ew0      !< East-West overlap
-      INTEGER(i4) :: i_perio    !< NEMO periodicity index
-      INTEGER(i4) :: i_pivot    !< NEMO pivot point index F(0),T(1)
-      INTEGER(i4) :: i_imin = 1 !< i-direction sub-domain lower left  point indice
-      INTEGER(i4) :: i_imax = 1 !< i-direction sub-domain upper right point indice
-      INTEGER(i4) :: i_jmin = 1 !< j-direction sub-domain lower left  point indice
-      INTEGER(i4) :: i_jmax = 1 !< j-direction sub-domain upper right point indice
-      INTEGER(i4) :: i_kmin = 1 !< k-direction sub-domain lower level indice
-      INTEGER(i4) :: i_kmax = 1 !< k-direction sub-domain upper level indice
-      INTEGER(i4) :: i_lmin = 1 !< l-direction sub-domain lower time indice
-      INTEGER(i4) :: i_lmax = 1 !< l-direction sub-domain upper time indice
-
-      INTEGER(i4) :: i_ighost = 0 !< i-direction ghost cell factor
-      INTEGER(i4) :: i_jghost = 0 !< j-direction ghost cell factor
-
-      INTEGER(i4), DIMENSION(2) :: i_iextra = 0 !< i-direction extra point
-      INTEGER(i4), DIMENSION(2) :: i_jextra = 0 !< j-direction extra point
+   PRIVATE :: dom__init_mpp                 ! initialise domain structure, given mpp file structure
+   PRIVATE :: dom__define                   ! define sub domain indices
+                                            ! define sub domain indices for input domain with
+   PRIVATE :: dom__define_cyclic_north_fold ! - cyclic east-west boundary and north fold boundary condition.
+   PRIVATE :: dom__define_north_fold        ! - north fold boundary condition.
+   PRIVATE :: dom__define_symmetric         ! - symmetric boundary condition across the equator.
+   PRIVATE :: dom__define_cyclic            ! - cyclic east-west boundary.
+   PRIVATE :: dom__define_closed            ! - cyclic east-west boundary.
+                                            ! compute size of sub domain
+   PRIVATE :: dom__size_no_pole             ! - without north fold condition
+   PRIVATE :: dom__size_no_pole_overlap     ! - without north fold condition, and which overlap east-west boundary
+   PRIVATE :: dom__size_no_pole_no_overlap  ! - without north fold condition, and which do not overlap east-west boundary
+   PRIVATE :: dom__size_pole                ! - with north fold condition
+   PRIVATE :: dom__size_pole_overlap        ! - with north fold condition, and which overlap east-west boundary
+   PRIVATE :: dom__size_pole_no_overlap     ! - with north fold condition, and which do not overlap east-west boundary
+                                            ! compute size of
+   PRIVATE :: dom__size_global              ! - global domain
+   PRIVATE :: dom__size_semi_global         ! - semi global domain 
+   PRIVATE :: dom__copy_unit                ! copy attribute structure
+
+   TYPE TDOM !< domain structure
+      TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim0  !< global domain dimension
+      TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim   !< sub domain dimension
+      INTEGER(i4) :: i_perio0                      !< NEMO periodicity index of global domain
+      INTEGER(i4) :: i_ew0                         !< East-West overlap of global domain
+      INTEGER(i4) :: i_perio                       !< NEMO periodicity index of sub domain
+      INTEGER(i4) :: i_pivot                       !< NEMO pivot point index F(0),T(1)
+      INTEGER(i4) :: i_imin = 0                    !< i-direction sub-domain lower left  point indice
+      INTEGER(i4) :: i_imax = 0                    !< i-direction sub-domain upper right point indice
+      INTEGER(i4) :: i_jmin = 0                    !< j-direction sub-domain lower left  point indice
+      INTEGER(i4) :: i_jmax = 0                    !< j-direction sub-domain upper right point indice
+
+      INTEGER(i4) :: i_bdy = 0                     !< boundary index : 0 = no boundary
+                                                   !<                  1 = north
+                                                   !<                  2 = south 
+                                                   !<                  3 = east 
+                                                   !<                  4 = west 
+      INTEGER(i4), DIMENSION(2,2) :: i_ghost0 = 0   !< array of ghost cell factor of global domain
+      INTEGER(i4), DIMENSION(2,2) :: i_ghost  = 0   !< array of ghost cell factor of sub domain
+
+      INTEGER(i4), DIMENSION(2) :: i_iextra = 0    !< i-direction extra point
+      INTEGER(i4), DIMENSION(2) :: i_jextra = 0    !< j-direction extra point
 
    END TYPE TDOM
@@ -92,10 +202,45 @@
 
    INTERFACE dom_init
-      MODULE PROCEDURE dom_init_file
-!      MODULE PROCEDURE dom_init_mpp
+      MODULE PROCEDURE dom__init_file
+      MODULE PROCEDURE dom__init_mpp
    END INTERFACE dom_init
 
+   INTERFACE dom_copy
+      MODULE PROCEDURE dom__copy_unit  ! copy attribute structure
+   END INTERFACE
+
 CONTAINS
    !-------------------------------------------------------------------
+   !> @brief
+   !> This subroutine copy an domain structure in another one
+   !> @details 
+   !> dummy function to get the same use for all structure
+   !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_dom=dom_copy(dom_init()) is forbidden).
+   !> This will create memory leaks.
+   !> @warning to avoid infinite loop, do not use any function inside 
+   !> this subroutine
+   !>
+   !> @author J.Paul
+   !> @date November, 2014 - Initial Version
+   !>
+   !> @param[in] td_dom   domain structure
+   !> @return copy of input domain structure
+   !-------------------------------------------------------------------
+   FUNCTION dom__copy_unit( td_dom )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TDOM), INTENT(IN)  :: td_dom
+      ! function
+      TYPE(TDOM) :: dom__copy_unit
+
+      ! local variable
+      !----------------------------------------------------------------
+
+      dom__copy_unit=td_dom
+      
+      END FUNCTION dom__copy_unit
+   !-------------------------------------------------------------------
    !> @brief This subroutine print some information about domain strucutre.
    !
@@ -103,7 +248,6 @@
    !> - Nov, 2013- Initial Version
    !
-   !> @param[inout] td_dom : dom structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[inout] td_dom dom structure
+   !-------------------------------------------------------------------
    SUBROUTINE dom_print(td_dom)
       IMPLICIT NONE
@@ -123,7 +267,10 @@
       END SELECT
 
-      WRITE(*,'((a,4(i0,1x)),(/a,i2,a,a),(/a,4(i0,1x)),(/a,i2/),10(/a,i0))') &
+      WRITE(*,'((a,4(i0,1x)),(/a,i2,a,a),2(/a,2(i0,1x)),(/a,4(i0,1x)),(/a,i2/),&
+      &          4(/a,i0),4(/a,2(i0,1x)))') &
       &  " global domain size ",td_dom%t_dim0(:)%i_len, &
       &  " domain periodicity ",td_dom%i_perio0,", pivot: ",TRIM(cl_pivot),   &
+      &  " i-direction ghost cell factor of global domain  ",td_dom%i_ghost0(jp_I,:), &
+      &  " j-direction ghost cell factor of global domain  ",td_dom%i_ghost0(jp_J,:), &
       &  " sub-domain size : ",td_dom%t_dim(:)%i_len,                         &
       &  " sub domain periodicity ",td_dom%i_perio,                           &
@@ -132,58 +279,181 @@
       &  " j-direction sub-domain lower left  point indice ",td_dom%i_jmin,   &
       &  " j-direction sub-domain upper right point indice ",td_dom%i_jmax,   &
-!      &  " k-direction sub-domain lower level indice       ",td_dom%i_kmin,   &
-!      &  " k-direction sub-domain upper level indice       ",td_dom%i_kmax,   &
-!      &  " l-direction sub-domain lower time indice        ",td_dom%i_lmin,   &
-!      &  " l-direction sub-domain upper time indice        ",td_dom%i_lmax,   &
-      &  " i-direction ghost cell factor                   ",td_dom%i_ighost, &
-      &  " j-direction ghost cell factor                   ",td_dom%i_jghost
+      &  " i-direction ghost cell factor                   ",td_dom%i_ghost(jp_I,:), &
+      &  " j-direction ghost cell factor                   ",td_dom%i_ghost(jp_J,:), &
+      &  " i-direction extra point for interpolation       ",td_dom%i_iextra(:), &
+      &  " j-direction extra point for interpolation       ",td_dom%i_jextra(:)
 
       END SUBROUTINE dom_print
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
    !> This function intialise domain structure, given open file structure,
-   !> and grid periodicity. 
+   !> and sub domain indices. 
+   !> @details
+   !> sub domain indices are computed, taking into account coarse grid
+   !> periodicity, pivot point, and East-West overlap.
    !
    !> @author J.Paul
    !> - June, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_perio : grid periodicity
-   !> @param[in] id_imin : i-direction sub-domain lower left  point indice
-   !> @param[in] id_imax : i-direction sub-domain upper right point indice
-   !> @param[in] id_jmin : j-direction sub-domain lower left  point indice
-   !> @param[in] id_jmax : j-direction sub-domain upper right point indice
-   !> @param[in] id_kmin : k-direction sub-domain lower level indice
-   !> @param[in] id_kmax : k-direction sub-domain upper level indice
-   !> @param[in] id_lmin : l-direction sub-domain lower time indice
-   !> @param[in] id_lmax : l-direction sub-domain upper time indice
+   !> @date September, 2014
+   !> - add boundary index
+   !> - add ghost cell factor
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !>
+   !> @param[in] td_mpp    mpp structure
+   !> @param[in] id_perio  grid periodicity
+   !> @param[in] id_imin   i-direction sub-domain lower left  point indice
+   !> @param[in] id_imax   i-direction sub-domain upper right point indice
+   !> @param[in] id_jmin   j-direction sub-domain lower left  point indice
+   !> @param[in] id_jmax   j-direction sub-domain upper right point indice
+   !> @param[in] cd_card   name of cardinal (for boundary)
    !> @return domain structure
-   !>
-   !> @todo
-   !> - initialiser domain
-   !> - add info new perio.. dans sortie
-   !-------------------------------------------------------------------
-   !> @code
-   TYPE(TDOM) FUNCTION dom_init_file( td_file, &
-   &                                  id_imin, id_imax, id_jmin, id_jmax )
-!   &                                  id_kmin, id_kmax, id_lmin, id_lmax )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TFILE), INTENT(IN) :: td_file 
-      INTEGER(i4), INTENT(IN), OPTIONAL :: id_imin
-      INTEGER(i4), INTENT(IN), OPTIONAL :: id_imax
-      INTEGER(i4), INTENT(IN), OPTIONAL :: id_jmin
-      INTEGER(i4), INTENT(IN), OPTIONAL :: id_jmax
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_kmin
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_kmax
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_lmin
-!      INTEGER(i4), INTENT(IN), OPTIONAL :: id_lmax
-
+   !-------------------------------------------------------------------
+   TYPE(TDOM) FUNCTION dom__init_mpp( td_mpp, &
+   &                                  id_imin, id_imax, id_jmin, id_jmax, &
+   &                                  cd_card )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP)      , INTENT(IN) :: td_mpp 
+
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_imin
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_imax
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_jmin
+      INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_jmax
+
+      CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: cd_card
       !local variable
       !----------------------------------------------------------------
 
       ! clean domain structure
-      CALL dom_clean(dom_init_file)
+      CALL dom_clean(dom__init_mpp)
+
+      IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
+
+         CALL logger_error( &
+         &  " DOM INIT: no processor file associated to mpp "//&
+         &  TRIM(td_mpp%c_name))
+
+      ELSE
+         ! global domain define by file
+
+         ! look for boundary index
+         IF( PRESENT(cd_card) )THEN
+            SELECT CASE(TRIM(cd_card))
+               CASE('north')
+                  dom__init_mpp%i_bdy=jp_north
+               CASE('south')
+                  dom__init_mpp%i_bdy=jp_south
+               CASE('east')
+                  dom__init_mpp%i_bdy=jp_east
+               CASE('west')
+                  dom__init_mpp%i_bdy=jp_west
+               CASE DEFAULT
+                  ! no boundary
+                  dom__init_mpp%i_bdy=0
+            END SELECT
+         ELSE
+            ! no boundary
+            dom__init_mpp%i_bdy=0
+         ENDIF
+
+         ! use global dimension define by mpp file
+         dom__init_mpp%t_dim0(:) = dim_copy(td_mpp%t_dim(:))
+
+         IF( td_mpp%i_perio < 0 .OR. td_mpp%i_perio > 6 )THEN
+            CALL logger_error("DOM INIT: invalid grid periodicity. "//&
+            &  "you should use grid_get_perio to compute it")
+         ELSE
+            dom__init_mpp%i_perio0=td_mpp%i_perio
+         ENDIF
+
+         ! global domain pivot point
+         SELECT CASE(dom__init_mpp%i_perio0)
+            CASE(3,4)
+               dom__init_mpp%i_pivot = 0
+            CASE(5,6)
+               dom__init_mpp%i_pivot = 1
+            CASE DEFAULT
+               dom__init_mpp%i_pivot = 0
+         END SELECT
+
+         ! add ghost cell factor of global domain
+         dom__init_mpp%i_ghost0(:,:)=0
+         SELECT CASE(dom__init_mpp%i_perio0)
+            CASE(0)
+               dom__init_mpp%i_ghost0(:,:)=1
+            CASE(1)
+               dom__init_mpp%i_ghost0(jp_J,:)=1
+            CASE(2)
+               dom__init_mpp%i_ghost0(jp_I,:)=1
+               dom__init_mpp%i_ghost0(jp_J,2)=1
+            CASE(3,5)
+               dom__init_mpp%i_ghost0(jp_I,:)=1
+               dom__init_mpp%i_ghost0(jp_J,1)=1
+            CASE(4,6)
+               dom__init_mpp%i_ghost0(jp_J,1)=1
+         END SELECT
+
+         ! look for EW overlap
+         dom__init_mpp%i_ew0=td_mpp%i_ew
+
+         ! initialise domain as global
+         dom__init_mpp%i_imin = 1 
+         dom__init_mpp%i_imax = dom__init_mpp%t_dim0(1)%i_len
+
+         dom__init_mpp%i_jmin = 1 
+         dom__init_mpp%i_jmax = dom__init_mpp%t_dim0(2)%i_len
+
+         ! sub domain dimension
+         dom__init_mpp%t_dim(:) = dim_copy(td_mpp%t_dim(:))
+
+         ! define sub domain indices 
+         CALL dom__define( dom__init_mpp, &
+         &                 id_imin, id_imax, id_jmin, id_jmax )
+
+      ENDIF
+
+   END FUNCTION dom__init_mpp
+   !-------------------------------------------------------------------
+   !> @brief 
+   !> This function intialise domain structure, given open file structure,
+   !> and sub domain indices. 
+   !> @details
+   !> sub domain indices are computed, taking into account coarse grid
+   !> periodicity, pivot point, and East-West overlap.
+   !
+   !> @author J.Paul
+   !> - June, 2013- Initial Version
+   !> @date September, 2014
+   !> - add boundary index
+   !> - add ghost cell factor
+   !>
+   !> @param[in] td_file   file structure
+   !> @param[in] id_perio  grid periodicity
+   !> @param[in] id_imin   i-direction sub-domain lower left  point indice
+   !> @param[in] id_imax   i-direction sub-domain upper right point indice
+   !> @param[in] id_jmin   j-direction sub-domain lower left  point indice
+   !> @param[in] id_jmax   j-direction sub-domain upper right point indice
+   !> @param[in] cd_card   name of cardinal (for boundary)
+   !> @return domain structure
+   !-------------------------------------------------------------------
+   TYPE(TDOM) FUNCTION dom__init_file( td_file, &
+   &                                   id_imin, id_imax, id_jmin, id_jmax, &
+   &                                   cd_card )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TFILE)      , INTENT(IN) :: td_file 
+
+      INTEGER(i4)      , INTENT(IN), OPTIONAL :: id_imin
+      INTEGER(i4)      , INTENT(IN), OPTIONAL :: id_imax
+      INTEGER(i4)      , INTENT(IN), OPTIONAL :: id_jmin
+      INTEGER(i4)      , INTENT(IN), OPTIONAL :: id_jmax
+
+      CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: cd_card
+      !local variable
+      !----------------------------------------------------------------
+
+      ! clean domain structure
+      CALL dom_clean(dom__init_file)
 
       IF( td_file%i_id == 0 )THEN
@@ -195,144 +465,97 @@
          ! global domain define by file
 
+         ! look for boundary index
+         IF( PRESENT(cd_card) )THEN
+            SELECT CASE(TRIM(cd_card))
+               CASE('north')
+                  dom__init_file%i_bdy=jp_north
+               CASE('south')
+                  dom__init_file%i_bdy=jp_south
+               CASE('east')
+                  dom__init_file%i_bdy=jp_east
+               CASE('west')
+                  dom__init_file%i_bdy=jp_west
+               CASE DEFAULT
+                  ! no boundary
+                  dom__init_file%i_bdy=0
+            END SELECT
+         ELSE
+            ! no boundary
+            dom__init_file%i_bdy=0
+         ENDIF
+
          ! use global dimension define by file
-         dom_init_file%t_dim0(:) = td_file%t_dim(:)
+         dom__init_file%t_dim0(:) = dim_copy(td_file%t_dim(:))
 
          IF( td_file%i_perio < 0 .OR. td_file%i_perio > 6 )THEN
             CALL logger_error("DOM INIT: invalid grid periodicity. "//&
-            &  "you should use dom_get_perio to compute it")
+            &  "you should use grid_get_perio to compute it")
          ELSE
-            dom_init_file%i_perio0=td_file%i_perio
+            dom__init_file%i_perio0=td_file%i_perio
          ENDIF
 
          ! global domain pivot point
-         SELECT CASE(dom_init_file%i_perio0)
+         SELECT CASE(dom__init_file%i_perio0)
             CASE(3,4)
-               dom_init_file%i_pivot = 0
+               dom__init_file%i_pivot = 0
             CASE(5,6)
-               dom_init_file%i_pivot = 1
+               dom__init_file%i_pivot = 1
             CASE DEFAULT
-               dom_init_file%i_pivot = 0
+               dom__init_file%i_pivot = 0
          END SELECT
 
+         ! add ghost cell factor of global domain
+         dom__init_file%i_ghost0(:,:)=0
+         SELECT CASE(dom__init_file%i_perio0)
+            CASE(0)
+               dom__init_file%i_ghost0(:,:)=1
+            CASE(1)
+               dom__init_file%i_ghost0(jp_J,:)=1
+            CASE(2)
+               dom__init_file%i_ghost0(jp_I,:)=1
+               dom__init_file%i_ghost0(jp_J,2)=1
+            CASE(3,5)
+               dom__init_file%i_ghost0(jp_I,:)=1
+               dom__init_file%i_ghost0(jp_J,1)=1
+            CASE(4,6)
+               dom__init_file%i_ghost0(jp_J,1)=1
+         END SELECT
+
          ! look for EW overlap
-         dom_init_file%i_ew0=td_file%i_ew
+         dom__init_file%i_ew0=td_file%i_ew
 
          ! initialise domain as global
-         dom_init_file%i_imin = 1 
-         dom_init_file%i_imax = dom_init_file%t_dim0(1)%i_len
-
-         dom_init_file%i_jmin = 1 
-         dom_init_file%i_jmax = dom_init_file%t_dim0(2)%i_len
-
-!         dom_init_file%i_kmin = 1 
-!         dom_init_file%i_kmax = dom_init_file%t_dim(3)%i_len
-!
-!         dom_init_file%i_lmin = 1 
-!         dom_init_file%i_lmax = dom_init_file%t_dim(4)%i_len
-
-         ! extract domain dimension
-         dom_init_file%t_dim(:) = td_file%t_dim(:)
-
-         ! define extract domain indices 
-         CALL dom__define( dom_init_file, &
-   &                       id_imin, id_imax, id_jmin, id_jmax )
-!   &                       id_kmin, id_kmax, id_lmin, id_lmax )
-
-      ENDIF
-
-   END FUNCTION dom_init_file
-   !> @endcode
- !  !-------------------------------------------------------------------
- !  !> @brief 
- !  !> This function intialise domain structure, given mpp structure,
- !  !> and variable name. domain indices could be specify.
- !  !
- !  !> @details
- !  !> 
- !  !
- !  !> @author J.Paul
- !  !> - Nov, 2013- Initial Version
- !  !
- !  !> @param[in] td_mpp : mpp structure
- !  !> @param[in] cd_varname : variable name
- !  !> @return domain structure
- !  !>
- !  !> @todo
- !  !> - initialiser domain
- !  !-------------------------------------------------------------------
- !  !> @code
- !  TYPE(TDOM) FUNCTION dom_init_mpp( td_mpp, cd_varname )
- !     IMPLICIT NONE
- !     ! Argument      
- !     TYPE(TMPP),       INTENT(IN) :: td_mpp 
- !     CHARACTER(LEN=*), INTENT(IN) :: cd_varname
- !     !----------------------------------------------------------------
-
- !     ! clean domain structure
- !     CALL dom_clean(dom_init_mpp)
-
- !     IF( ASSOCIATED(td_mpp%t_proc) )THEN
-
- !        CALL logger_error( " INIT: mpp strcuture "//TRIM(td_mpp%c_name)//&
- !        &               " not define" )
-
- !     ELSE
- !        ! global domain define by mpp
-
- !        ! use global dimension define by mpp
- !        dom_init_mpp%t_dim(:) = td_mpp%t_dim(:)
-
- !        ! get global domain periodicity ??
- !        dom_init_mpp%i_perio =  dom_get_perio(td_mpp, cd_varname)
-
- !        ! global domain pivot point
- !        SELECT CASE(dom_init%i_perio)
- !           CASE(3,4)
- !              dom_init%i_pivot = 0
- !           CASE(5,6)
- !              dom_init%i_pivot = 1
- !           CASE DEFAULT
- !              dom_init%i_pivot = 0
- !        END SELECT
-
- !        ! initialise domain as global
- !        dom_init_mpp%i_imin = 1 
- !        dom_init_mpp%i_imax = dom_init_mpp%t_dim(1)%i_len
-
- !        dom_init_mpp%i_jmin = 1 
- !        dom_init_mpp%i_jmax = dom_init_mpp%t_dim(2)%i_len
-
- !        dom_init_mpp%i_kmin = 1 
- !        dom_init_mpp%i_kmax = dom_init_mpp%t_dim(3)%i_len
-
- !        dom_init_mpp%i_lmin = 1 
- !        dom_init_mpp%i_lmax = dom_init_mpp%t_dim(4)%i_len
-
- !     ENDIF
-
- !  END FUNCTION dom_init_mpp
- !  !> @endcode
+         dom__init_file%i_imin = 1 
+         dom__init_file%i_imax = dom__init_file%t_dim0(1)%i_len
+
+         dom__init_file%i_jmin = 1 
+         dom__init_file%i_jmax = dom__init_file%t_dim0(2)%i_len
+
+         ! sub domain dimension
+         dom__init_file%t_dim(:) = dim_copy(td_file%t_dim(:))
+
+         ! define sub domain indices 
+         CALL dom__define( dom__init_file, &
+         &                 id_imin, id_imax, id_jmin, id_jmax )
+
+      ENDIF
+
+   END FUNCTION dom__init_file
    !-------------------------------------------------------------------
    !> @brief 
-   !> This subroutine define extract domain indices, and compute the size 
-   !> of the domain.
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain structure
-   !> @param[in] id_imin : i-direction sub-domain lower left  point indice
-   !> @param[in] id_imax : i-direction sub-domain upper right point indice
-   !> @param[in] id_jmin : j-direction sub-domain lower left  point indice
-   !> @param[in] id_jmax : j-direction sub-domain upper right point indice
-   !> @param[in] id_kmin : k-direction sub-domain lower level indice
-   !> @param[in] id_kmax : k-direction sub-domain upper level indice
-   !> @param[in] id_lmin : l-direction sub-domain lower time indice
-   !> @param[in] id_lmax : l-direction sub-domain upper time indice
-   !-------------------------------------------------------------------
-   !> @code
+   !> This subroutine define sub domain indices, and compute the size 
+   !> of the sub domain.
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain structure
+   !> @param[in] id_imin   i-direction sub-domain lower left  point indice
+   !> @param[in] id_imax   i-direction sub-domain upper right point indice
+   !> @param[in] id_jmin   j-direction sub-domain lower left  point indice
+   !> @param[in] id_jmax   j-direction sub-domain upper right point indice
+   !-------------------------------------------------------------------
    SUBROUTINE dom__define(td_dom, &
    &                      id_imin, id_imax, id_jmin, id_jmax )
-!   &                      id_kmin, id_kmax, id_lmin, id_lmax )
       IMPLICIT NONE
       ! Argument      
